diff --git a/src/common/dsp/effect/airwindows/airwindows_adapter.cpp b/src/common/dsp/effect/airwindows/airwindows_adapter.cpp
index b3a725a36..71b8ed969 100644
--- a/src/common/dsp/effect/airwindows/airwindows_adapter.cpp
+++ b/src/common/dsp/effect/airwindows/airwindows_adapter.cpp
@@ -123,7 +123,6 @@ void AirWindowsEffect::setupSubFX( int sfx )
    
    char fxname[1024];
    airwin->getEffectName(fxname);
-   std::cout << "Constructed " << fxname << " " << airwin->paramCount << std::endl;
    lastSelected = sfx;
    init_ctrltypes();
 }
diff --git a/src/common/gui/CMenuAsSlider.cpp b/src/common/gui/CMenuAsSlider.cpp
index daf7d57c5..90aea1d45 100644
--- a/src/common/gui/CMenuAsSlider.cpp
+++ b/src/common/gui/CMenuAsSlider.cpp
@@ -112,6 +112,22 @@ void CMenuAsSlider::onSkinChanged()
                                                               dynamic_cast<CScalableBitmap*>( pBackground ),
                                                               associatedBitmapStore,
                                                               Surge::UI::Skin::HoverType::HOVER);
-   std::cout << pBackground << " " << pBackgroundHover << std::endl;
-   
+}
+
+bool CMenuAsSlider::onWheel( const VSTGUI::CPoint &where, const float &distance, const VSTGUI::CButtonState &buttons ) {
+   wheelDistance += distance;
+   float dDistance = 1.f / std::max( ( iMax - iMin ), 1 );
+   if( wheelDistance > 1 ) {
+      wheelDistance -= 1;
+      setValue( limit_range( getValue() - dDistance, 0.f, 1.f ) );
+      if( listener )
+         listener->valueChanged(this);
+   }
+   if( wheelDistance < -1 ) {
+      wheelDistance += 1;
+      setValue( limit_range( getValue() + dDistance, 0.f, 1.f ) );
+      if( listener )
+         listener->valueChanged(this);
+   }
+   return true;
 }
diff --git a/src/common/gui/CMenuAsSlider.h b/src/common/gui/CMenuAsSlider.h
index 757d66c58..714b53d57 100644
--- a/src/common/gui/CMenuAsSlider.h
+++ b/src/common/gui/CMenuAsSlider.h
@@ -32,7 +32,7 @@ class CMenuAsSlider : public VSTGUI::CControl, public Surge::UI::SkinConsumingCo
    virtual void draw(VSTGUI::CDrawContext*) override;
    void setLabel( const char* lab ) { label = lab; }
    
-   // virtual bool onWheel(const VSTGUI::CPoint& where, const float &distane, const VSTGUI::CButtonState& buttons) override;
+   virtual bool onWheel(const VSTGUI::CPoint& where, const float &distane, const VSTGUI::CButtonState& buttons) override;
 
    virtual VSTGUI::CMouseEventResult onMouseDown(VSTGUI::CPoint& where, const VSTGUI::CButtonState& buttons) override; ///< called when a mouse down event occurs
    virtual VSTGUI::CMouseEventResult onMouseUp(VSTGUI::CPoint& where, const VSTGUI::CButtonState& buttons) override
@@ -43,6 +43,7 @@ class CMenuAsSlider : public VSTGUI::CControl, public Surge::UI::SkinConsumingCo
    virtual VSTGUI::CMouseEventResult onMouseEntered(VSTGUI::CPoint& where, const VSTGUI::CButtonState& buttons) override
       {
          isHover = true;
+         wheelDistance = 0;
          invalid();
          return VSTGUI::kMouseEventHandled;
       }
@@ -50,11 +51,15 @@ class CMenuAsSlider : public VSTGUI::CControl, public Surge::UI::SkinConsumingCo
    virtual VSTGUI::CMouseEventResult onMouseExited(VSTGUI::CPoint& where, const VSTGUI::CButtonState& buttons) override
       {
          isHover = false;
+         wheelDistance = 0;
          invalid();
          return VSTGUI::kMouseEventHandled;
       }
 
 
+   void setMinMax( int i, int x ) {
+      iMin = i; iMax = x;
+   }
    
    CLASS_METHODS(CMenuAsSlider, CControl)
    bool in_hover = false;
@@ -66,5 +71,7 @@ class CMenuAsSlider : public VSTGUI::CControl, public Surge::UI::SkinConsumingCo
    VSTGUI::CBitmap *pBackground = nullptr, *pBackgroundHover = nullptr;
    std::string label = "";
    bool isHover = false;
-   bool wheelInitiatedEdit = false;
+   float wheelDistance = 0;
+   
+   int iMin = 0, iMax = 10;
 };
diff --git a/src/common/gui/SurgeGUIEditor.cpp b/src/common/gui/SurgeGUIEditor.cpp
index f84b45f2d..43425aa47 100644
--- a/src/common/gui/SurgeGUIEditor.cpp
+++ b/src/common/gui/SurgeGUIEditor.cpp
@@ -1955,6 +1955,8 @@ void SurgeGUIEditor::openOrRecreateEditor()
                                         bitmapStore,
                                         &(synth->storage));
             hs->setSkin( currentSkin, bitmapStore );
+            hs->setValue( p->get_value_f01() );
+            hs->setMinMax( p->val_min.i, p->val_max.i );
             hs->setLabel(p->get_name());
             frame->addView( hs );
             param[i] = hs;
@@ -3253,11 +3255,11 @@ int32_t SurgeGUIEditor::controlModifierClicked(CControl* control, CButtonState b
 #endif
                         
                         auto b = addCallbackMenu( useSubMenus ? sub : contextMenu, displaytxt.c_str(),
-                                                 [this,p,i]() {
-                                                    std::cout << "Setting to " << i << std::endl;
-                                                    p->val.i = i;
-                                                    synth->refresh_editor = true;
-                                                 }
+                                                  [this,p,i, tag]() {
+                                                     float ef = (1.0f * i - p->val_min.i) / (p->val_max.i - p->val_min.i);
+                                                     synth->setParameter01( p->id, ef, false, false );
+                                                     synth->refresh_editor=true;
+                                                  }
                            );
                         eid++;
                         if( i == p->val.i ) {
